using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Drawing.Printing;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;
using System.Diagnostics;

namespace PrintGroupingGrid
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand1;
		private System.Data.SqlClient.SqlCommand sqlInsertCommand1;
		private System.Data.SqlClient.SqlCommand sqlUpdateCommand1;
		private System.Data.SqlClient.SqlCommand sqlDeleteCommand1;
		private System.Data.SqlClient.SqlConnection sqlConnection1;
		private System.Data.SqlClient.SqlDataAdapter sqlDataAdapter1;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand2;
		private System.Data.SqlClient.SqlCommand sqlInsertCommand2;
		private System.Data.SqlClient.SqlCommand sqlUpdateCommand2;
		private System.Data.SqlClient.SqlCommand sqlDeleteCommand2;
		private System.Data.SqlClient.SqlDataAdapter sqlDataAdapter2;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand3;
		private System.Data.SqlClient.SqlCommand sqlInsertCommand3;
		private System.Data.SqlClient.SqlCommand sqlUpdateCommand3;
		private System.Data.SqlClient.SqlCommand sqlDeleteCommand3;
		private System.Data.SqlClient.SqlDataAdapter sqlDataAdapter3;
		private PrintGroupingGrid.DataSet1 dataSet11;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItemExpandAll;
		private System.Windows.Forms.MenuItem menuItemCollapseAll;
		private System.Windows.Forms.MenuItem menuItemPrint;
		private System.Windows.Forms.MenuItem menuItemExit;
		private System.Windows.Forms.MenuItem menuItemPrintPreview;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.InitializeDataSet();

			// Example: If you want to manually add foreign key columns and don't autopopulate them
			bool manualForeignKey = true;
			if (manualForeignKey)
			{
				// The following code shows how to avoid columns being automatically added to the parent table for each
				// column in the foreign table. It does instead manually add those columns
				// from the referenced table by setting ShowRelationFields = ShowRelationFields.Hide
				// and calling Columns.Add("ForeignTable.ColumnName")

				// Reset Relations - so that they get recreated from scratch
				this.gridGroupingControl1.TableDescriptor.Relations.Reset();
				gridGroupingControl1.TableDescriptor.VisibleColumns.Remove("Description");

				// NOTE: If you open DataSet1.xsd and right click on the 
				// relation between Products and Suppliers and select "Edit Relation" 
				// you will notice in the dialog that is shown that the 
				// DataSet property "Create foreign key constraint only" has been checked.
				// This setting allows the grouping engine to differentiate between
				// foreign key relations and master details relations when autopopulating
				// relations.
				//

				this.gridGroupingControl1.ShowRelationFields = ShowRelationFields.Hide;

				GridTableDescriptor td = this.gridGroupingControl1.TableDescriptor.Relations[0].ChildTableDescriptor;
				int n = td.Columns.Add("Suppliers.CompanyName");   // . will be replaced with '_' in column.Name
				Console.WriteLine(td.Columns[n].Name);

				td.VisibleColumns.Clear();
				td.VisibleColumns.AddRange(
					new GridVisibleColumnDescriptor[] {
														  new GridVisibleColumnDescriptor("ProductID"),
														  new GridVisibleColumnDescriptor("ProductName"),
														  new GridVisibleColumnDescriptor("UnitPrice"),
					// new GridVisibleColumnDescriptor("Suppliers_CompanyName")
				});

				td.RecordFilters.Add("[ProductID] < 10");
			}

			// Show group area
			this.gridGroupingControl1.ShowGroupDropArea = true;

			// Additionial table descriptors currently habe to be added manually. We
			// plan to provide a TableDescriptor.ShowInGroupDropArea property later
			// to make this easier.
			AddGroupDropAreas(this.gridGroupingControl1.Table);
			
			this.gridGroupingControl1.Table.Records[0].IsExpanded = true;
			this.gridGroupingControl1.Table.Records[2].IsExpanded = true;


		}
		
		private void menuItemExpandAll_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.Table.ExpandAllRecords();
		}

		private void menuItemCollapseAll_Click(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.Table.CollapseAllRecords();
		}

		private void menuItemPrint_Click(object sender, System.EventArgs e)
		{
			GridPrintToFitDocument pd = new GridPrintToFitDocument(this.gridGroupingControl1.TableControl, false); 
			PrintDialog printDialog = new PrintDialog(); 
			printDialog.Document = pd;
			pd.DefaultPageSettings.Landscape = true;
			printDialog.ShowDialog(); 
		}

		private void menuItemPrintPreview_Click(object sender, System.EventArgs e)
		{
			// Print the contents of the grouping grid.
			GridPrintToFitDocument pd = new GridPrintToFitDocument(this.gridGroupingControl1.TableControl, true); 
			PrintPreviewDialog ppv = new PrintPreviewDialog(); 
			ppv.Document = pd; 
			pd.DefaultPageSettings.Landscape = true;
			ppv.ShowDialog(); 

			// NOTE: There is a known problem when the width of the nested table is larger
			// than the width of the parent table. Some columns that do not fit on the same
			// page as the last column of the parent table will be omitted. We are working
			// on a solution for this.
		}

		private void menuItemExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void AddGroupDropAreas(GridTable table)
		{
			Syncfusion.Grouping.RelationDescriptor rd = table.TableDescriptor.ParentRelation;
			if (rd != null && rd.RelationKind != Syncfusion.Grouping.RelationKind.RelatedMasterDetails)
				return;

			foreach(GridTable t in table.RelatedTables)
			{
				Console.WriteLine("AddGroupDropArea " + t.Info);

				gridGroupingControl1.AddGroupDropArea(t);
				//recurse...
				AddGroupDropAreas(t);
			}
		}

		string xmlName = "CatgeoryProductsShippers.xml";
		bool msdeAvailable = false;

		void InitializeDataSet()
		{
			if (msdeAvailable)
			{
				// Initialize the data set

				this.dataSet11.BeginInit();

				// Order is important here - first fill tables that are referenced with 
				// foreign keys, then tables that have references to others.

				this.sqlDataAdapter1.Fill(this.dataSet11);
				this.sqlDataAdapter3.Fill(this.dataSet11);
				this.sqlDataAdapter2.Fill(this.dataSet11);

				this.dataSet11.EndInit();

				this.dataSet11.WriteXml(xmlName);
			}
			else
			{
				// Read from a xml file instead. 
				if (!ReadXml(this.dataSet11, xmlName))
				{
					// If no xml found, try again with MSDE
					msdeAvailable = true;
					InitializeDataSet();
				}
			}

		}

		bool ReadXml(DataSet ds, string xmlFileName)
		{
			// Check both in parent folder and Parent\Data folders.
			string xmlDataFileName = @"Data\" + xmlFileName;
			for (int n = 0; n < 10; n++)
			{
				if (System.IO.File.Exists(xmlFileName))
				{
					ds.ReadXml(xmlFileName);
					return true;
				}
				if (System.IO.File.Exists(xmlDataFileName))
				{
					ds.ReadXml(xmlDataFileName);
					return true;
				}
				xmlFileName = @"..\" + xmlFileName;
				xmlDataFileName = @"..\" + xmlDataFileName;
			}

			return false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			Syncfusion.Windows.Forms.Grid.Grouping.GridRelationDescriptor gridRelationDescriptor1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridRelationDescriptor();
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.dataSet11 = new PrintGroupingGrid.DataSet1();
			this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlInsertCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlDeleteCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlDataAdapter1 = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlSelectCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlInsertCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlDeleteCommand2 = new System.Data.SqlClient.SqlCommand();
			this.sqlDataAdapter2 = new System.Data.SqlClient.SqlDataAdapter();
			this.sqlSelectCommand3 = new System.Data.SqlClient.SqlCommand();
			this.sqlInsertCommand3 = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateCommand3 = new System.Data.SqlClient.SqlCommand();
			this.sqlDeleteCommand3 = new System.Data.SqlClient.SqlCommand();
			this.sqlDataAdapter3 = new System.Data.SqlClient.SqlDataAdapter();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItemExpandAll = new System.Windows.Forms.MenuItem();
			this.menuItemCollapseAll = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItemPrint = new System.Windows.Forms.MenuItem();
			this.menuItemPrintPreview = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItemExit = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.DataSource = this.dataSet11.Categories;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(672, 360);
			this.gridGroupingControl1.TabIndex = 0;
			gridRelationDescriptor1.ChildTableDescriptor.VisibleColumns.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridVisibleColumnDescriptor[] {
																																							  new Syncfusion.Windows.Forms.Grid.Grouping.GridVisibleColumnDescriptor("ProductID"),
																																							  new Syncfusion.Windows.Forms.Grid.Grouping.GridVisibleColumnDescriptor("ProductName"),
																																							  new Syncfusion.Windows.Forms.Grid.Grouping.GridVisibleColumnDescriptor("UnitPrice"),
																																							  new Syncfusion.Windows.Forms.Grid.Grouping.GridVisibleColumnDescriptor("Suppliers_CompanyName")
																																						  });
			gridRelationDescriptor1.MappingName = "CategoriesProducts";
			this.gridGroupingControl1.TableDescriptor.Relations.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridRelationDescriptor[] {
																																				 gridRelationDescriptor1});
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			// 
			// dataSet11
			// 
			this.dataSet11.DataSetName = "DataSet1";
			this.dataSet11.Locale = new System.Globalization.CultureInfo("en-US");
			this.dataSet11.Namespace = "http://www.tempuri.org/DataSet1.xsd";
			// 
			// sqlSelectCommand1
			// 
			this.sqlSelectCommand1.CommandText = "SELECT CategoryID, CategoryName, Description, Picture FROM Categories";
			this.sqlSelectCommand1.Connection = this.sqlConnection1;
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "data source=(local)\\NETSDK;initial catalog=Northwind;integrated security=SSPI;per" +
				"sist security info=True;workstation id=localhost;packet size=4096";
			// 
			// sqlInsertCommand1
			// 
			this.sqlInsertCommand1.CommandText = "INSERT INTO Categories(CategoryName, Description, Picture) VALUES (@CategoryName," +
				" @Description, @Picture); SELECT CategoryID, CategoryName, Description, Picture " +
				"FROM Categories WHERE (CategoryID = @@IDENTITY)";
			this.sqlInsertCommand1.Connection = this.sqlConnection1;
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CategoryName", System.Data.SqlDbType.NVarChar, 15, "CategoryName"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Description", System.Data.SqlDbType.NVarChar, 1073741823, "Description"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Picture", System.Data.SqlDbType.VarBinary, 2147483647, "Picture"));
			// 
			// sqlUpdateCommand1
			// 
			this.sqlUpdateCommand1.CommandText = @"UPDATE Categories SET CategoryName = @CategoryName, Description = @Description, Picture = @Picture WHERE (CategoryID = @Original_CategoryID) AND (CategoryName = @Original_CategoryName); SELECT CategoryID, CategoryName, Description, Picture FROM Categories WHERE (CategoryID = @CategoryID)";
			this.sqlUpdateCommand1.Connection = this.sqlConnection1;
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CategoryName", System.Data.SqlDbType.NVarChar, 15, "CategoryName"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Description", System.Data.SqlDbType.NVarChar, 1073741823, "Description"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Picture", System.Data.SqlDbType.VarBinary, 2147483647, "Picture"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CategoryID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CategoryID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CategoryName", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CategoryName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CategoryID", System.Data.SqlDbType.Int, 4, "CategoryID"));
			// 
			// sqlDeleteCommand1
			// 
			this.sqlDeleteCommand1.CommandText = "DELETE FROM Categories WHERE (CategoryID = @Original_CategoryID) AND (CategoryNam" +
				"e = @Original_CategoryName)";
			this.sqlDeleteCommand1.Connection = this.sqlConnection1;
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CategoryID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CategoryID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CategoryName", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CategoryName", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDataAdapter1
			// 
			this.sqlDataAdapter1.DeleteCommand = this.sqlDeleteCommand1;
			this.sqlDataAdapter1.InsertCommand = this.sqlInsertCommand1;
			this.sqlDataAdapter1.SelectCommand = this.sqlSelectCommand1;
			this.sqlDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "Categories", new System.Data.Common.DataColumnMapping[] {
																																																					new System.Data.Common.DataColumnMapping("CategoryID", "CategoryID"),
																																																					new System.Data.Common.DataColumnMapping("CategoryName", "CategoryName"),
																																																					new System.Data.Common.DataColumnMapping("Description", "Description"),
																																																					new System.Data.Common.DataColumnMapping("Picture", "Picture")})});
			this.sqlDataAdapter1.UpdateCommand = this.sqlUpdateCommand1;
			// 
			// sqlSelectCommand2
			// 
			this.sqlSelectCommand2.CommandText = "SELECT ProductID, ProductName, SupplierID, CategoryID, QuantityPerUnit, UnitPrice" +
				", UnitsInStock, UnitsOnOrder, ReorderLevel, Discontinued FROM Products";
			this.sqlSelectCommand2.Connection = this.sqlConnection1;
			// 
			// sqlInsertCommand2
			// 
			this.sqlInsertCommand2.CommandText = @"INSERT INTO Products(ProductName, SupplierID, CategoryID, QuantityPerUnit, UnitPrice, UnitsInStock, UnitsOnOrder, ReorderLevel, Discontinued) VALUES (@ProductName, @SupplierID, @CategoryID, @QuantityPerUnit, @UnitPrice, @UnitsInStock, @UnitsOnOrder, @ReorderLevel, @Discontinued); SELECT ProductID, ProductName, SupplierID, CategoryID, QuantityPerUnit, UnitPrice, UnitsInStock, UnitsOnOrder, ReorderLevel, Discontinued FROM Products WHERE (ProductID = @@IDENTITY)";
			this.sqlInsertCommand2.Connection = this.sqlConnection1;
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ProductName", System.Data.SqlDbType.NVarChar, 40, "ProductName"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@SupplierID", System.Data.SqlDbType.Int, 4, "SupplierID"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CategoryID", System.Data.SqlDbType.Int, 4, "CategoryID"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@QuantityPerUnit", System.Data.SqlDbType.NVarChar, 20, "QuantityPerUnit"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@UnitPrice", System.Data.SqlDbType.Money, 8, "UnitPrice"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@UnitsInStock", System.Data.SqlDbType.SmallInt, 2, "UnitsInStock"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@UnitsOnOrder", System.Data.SqlDbType.SmallInt, 2, "UnitsOnOrder"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ReorderLevel", System.Data.SqlDbType.SmallInt, 2, "ReorderLevel"));
			this.sqlInsertCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Discontinued", System.Data.SqlDbType.Bit, 1, "Discontinued"));
			// 
			// sqlUpdateCommand2
			// 
			this.sqlUpdateCommand2.CommandText = @"UPDATE Products SET ProductName = @ProductName, SupplierID = @SupplierID, CategoryID = @CategoryID, QuantityPerUnit = @QuantityPerUnit, UnitPrice = @UnitPrice, UnitsInStock = @UnitsInStock, UnitsOnOrder = @UnitsOnOrder, ReorderLevel = @ReorderLevel, Discontinued = @Discontinued WHERE (ProductID = @Original_ProductID) AND (CategoryID = @Original_CategoryID OR @Original_CategoryID IS NULL AND CategoryID IS NULL) AND (Discontinued = @Original_Discontinued) AND (ProductName = @Original_ProductName) AND (QuantityPerUnit = @Original_QuantityPerUnit OR @Original_QuantityPerUnit IS NULL AND QuantityPerUnit IS NULL) AND (ReorderLevel = @Original_ReorderLevel OR @Original_ReorderLevel IS NULL AND ReorderLevel IS NULL) AND (SupplierID = @Original_SupplierID OR @Original_SupplierID IS NULL AND SupplierID IS NULL) AND (UnitPrice = @Original_UnitPrice OR @Original_UnitPrice IS NULL AND UnitPrice IS NULL) AND (UnitsInStock = @Original_UnitsInStock OR @Original_UnitsInStock IS NULL AND UnitsInStock IS NULL) AND (UnitsOnOrder = @Original_UnitsOnOrder OR @Original_UnitsOnOrder IS NULL AND UnitsOnOrder IS NULL); SELECT ProductID, ProductName, SupplierID, CategoryID, QuantityPerUnit, UnitPrice, UnitsInStock, UnitsOnOrder, ReorderLevel, Discontinued FROM Products WHERE (ProductID = @ProductID)";
			this.sqlUpdateCommand2.Connection = this.sqlConnection1;
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ProductName", System.Data.SqlDbType.NVarChar, 40, "ProductName"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@SupplierID", System.Data.SqlDbType.Int, 4, "SupplierID"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CategoryID", System.Data.SqlDbType.Int, 4, "CategoryID"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@QuantityPerUnit", System.Data.SqlDbType.NVarChar, 20, "QuantityPerUnit"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@UnitPrice", System.Data.SqlDbType.Money, 8, "UnitPrice"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@UnitsInStock", System.Data.SqlDbType.SmallInt, 2, "UnitsInStock"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@UnitsOnOrder", System.Data.SqlDbType.SmallInt, 2, "UnitsOnOrder"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ReorderLevel", System.Data.SqlDbType.SmallInt, 2, "ReorderLevel"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Discontinued", System.Data.SqlDbType.Bit, 1, "Discontinued"));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ProductID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ProductID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CategoryID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CategoryID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Discontinued", System.Data.SqlDbType.Bit, 1, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Discontinued", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ProductName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ProductName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_QuantityPerUnit", System.Data.SqlDbType.NVarChar, 20, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "QuantityPerUnit", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ReorderLevel", System.Data.SqlDbType.SmallInt, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ReorderLevel", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_SupplierID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "SupplierID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_UnitPrice", System.Data.SqlDbType.Money, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "UnitPrice", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_UnitsInStock", System.Data.SqlDbType.SmallInt, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "UnitsInStock", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_UnitsOnOrder", System.Data.SqlDbType.SmallInt, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "UnitsOnOrder", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ProductID", System.Data.SqlDbType.Int, 4, "ProductID"));
			// 
			// sqlDeleteCommand2
			// 
			this.sqlDeleteCommand2.CommandText = @"DELETE FROM Products WHERE (ProductID = @Original_ProductID) AND (CategoryID = @Original_CategoryID OR @Original_CategoryID IS NULL AND CategoryID IS NULL) AND (Discontinued = @Original_Discontinued) AND (ProductName = @Original_ProductName) AND (QuantityPerUnit = @Original_QuantityPerUnit OR @Original_QuantityPerUnit IS NULL AND QuantityPerUnit IS NULL) AND (ReorderLevel = @Original_ReorderLevel OR @Original_ReorderLevel IS NULL AND ReorderLevel IS NULL) AND (SupplierID = @Original_SupplierID OR @Original_SupplierID IS NULL AND SupplierID IS NULL) AND (UnitPrice = @Original_UnitPrice OR @Original_UnitPrice IS NULL AND UnitPrice IS NULL) AND (UnitsInStock = @Original_UnitsInStock OR @Original_UnitsInStock IS NULL AND UnitsInStock IS NULL) AND (UnitsOnOrder = @Original_UnitsOnOrder OR @Original_UnitsOnOrder IS NULL AND UnitsOnOrder IS NULL)";
			this.sqlDeleteCommand2.Connection = this.sqlConnection1;
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ProductID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ProductID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CategoryID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CategoryID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Discontinued", System.Data.SqlDbType.Bit, 1, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Discontinued", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ProductName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ProductName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_QuantityPerUnit", System.Data.SqlDbType.NVarChar, 20, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "QuantityPerUnit", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ReorderLevel", System.Data.SqlDbType.SmallInt, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ReorderLevel", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_SupplierID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "SupplierID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_UnitPrice", System.Data.SqlDbType.Money, 8, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "UnitPrice", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_UnitsInStock", System.Data.SqlDbType.SmallInt, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "UnitsInStock", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand2.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_UnitsOnOrder", System.Data.SqlDbType.SmallInt, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "UnitsOnOrder", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDataAdapter2
			// 
			this.sqlDataAdapter2.DeleteCommand = this.sqlDeleteCommand2;
			this.sqlDataAdapter2.InsertCommand = this.sqlInsertCommand2;
			this.sqlDataAdapter2.SelectCommand = this.sqlSelectCommand2;
			this.sqlDataAdapter2.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "Products", new System.Data.Common.DataColumnMapping[] {
																																																				  new System.Data.Common.DataColumnMapping("ProductID", "ProductID"),
																																																				  new System.Data.Common.DataColumnMapping("ProductName", "ProductName"),
																																																				  new System.Data.Common.DataColumnMapping("SupplierID", "SupplierID"),
																																																				  new System.Data.Common.DataColumnMapping("CategoryID", "CategoryID"),
																																																				  new System.Data.Common.DataColumnMapping("QuantityPerUnit", "QuantityPerUnit"),
																																																				  new System.Data.Common.DataColumnMapping("UnitPrice", "UnitPrice"),
																																																				  new System.Data.Common.DataColumnMapping("UnitsInStock", "UnitsInStock"),
																																																				  new System.Data.Common.DataColumnMapping("UnitsOnOrder", "UnitsOnOrder"),
																																																				  new System.Data.Common.DataColumnMapping("ReorderLevel", "ReorderLevel"),
																																																				  new System.Data.Common.DataColumnMapping("Discontinued", "Discontinued")})});
			this.sqlDataAdapter2.UpdateCommand = this.sqlUpdateCommand2;
			// 
			// sqlSelectCommand3
			// 
			this.sqlSelectCommand3.CommandText = "SELECT SupplierID, CompanyName, ContactName, ContactTitle, Address, City, Region," +
				" PostalCode, Country, Phone, Fax, HomePage FROM Suppliers";
			this.sqlSelectCommand3.Connection = this.sqlConnection1;
			// 
			// sqlInsertCommand3
			// 
			this.sqlInsertCommand3.CommandText = @"INSERT INTO Suppliers(CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax, HomePage) VALUES (@CompanyName, @ContactName, @ContactTitle, @Address, @City, @Region, @PostalCode, @Country, @Phone, @Fax, @HomePage); SELECT SupplierID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax, HomePage FROM Suppliers WHERE (SupplierID = @@IDENTITY)";
			this.sqlInsertCommand3.Connection = this.sqlConnection1;
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, "CompanyName"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, "ContactName"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, "ContactTitle"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, "Address"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, "City"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, "Region"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, "PostalCode"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, "Country"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, "Phone"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, "Fax"));
			this.sqlInsertCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@HomePage", System.Data.SqlDbType.NVarChar, 1073741823, "HomePage"));
			// 
			// sqlUpdateCommand3
			// 
			this.sqlUpdateCommand3.CommandText = @"UPDATE Suppliers SET CompanyName = @CompanyName, ContactName = @ContactName, ContactTitle = @ContactTitle, Address = @Address, City = @City, Region = @Region, PostalCode = @PostalCode, Country = @Country, Phone = @Phone, Fax = @Fax, HomePage = @HomePage WHERE (SupplierID = @Original_SupplierID) AND (Address = @Original_Address OR @Original_Address IS NULL AND Address IS NULL) AND (City = @Original_City OR @Original_City IS NULL AND City IS NULL) AND (CompanyName = @Original_CompanyName) AND (ContactName = @Original_ContactName OR @Original_ContactName IS NULL AND ContactName IS NULL) AND (ContactTitle = @Original_ContactTitle OR @Original_ContactTitle IS NULL AND ContactTitle IS NULL) AND (Country = @Original_Country OR @Original_Country IS NULL AND Country IS NULL) AND (Fax = @Original_Fax OR @Original_Fax IS NULL AND Fax IS NULL) AND (Phone = @Original_Phone OR @Original_Phone IS NULL AND Phone IS NULL) AND (PostalCode = @Original_PostalCode OR @Original_PostalCode IS NULL AND PostalCode IS NULL) AND (Region = @Original_Region OR @Original_Region IS NULL AND Region IS NULL); SELECT SupplierID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax, HomePage FROM Suppliers WHERE (SupplierID = @SupplierID)";
			this.sqlUpdateCommand3.Connection = this.sqlConnection1;
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, "CompanyName"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, "ContactName"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, "ContactTitle"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, "Address"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, "City"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, "Region"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, "PostalCode"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, "Country"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, "Phone"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, "Fax"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@HomePage", System.Data.SqlDbType.NVarChar, 1073741823, "HomePage"));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_SupplierID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "SupplierID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Address", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "City", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CompanyName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactTitle", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Country", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Fax", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Phone", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "PostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Region", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@SupplierID", System.Data.SqlDbType.Int, 4, "SupplierID"));
			// 
			// sqlDeleteCommand3
			// 
			this.sqlDeleteCommand3.CommandText = @"DELETE FROM Suppliers WHERE (SupplierID = @Original_SupplierID) AND (Address = @Original_Address OR @Original_Address IS NULL AND Address IS NULL) AND (City = @Original_City OR @Original_City IS NULL AND City IS NULL) AND (CompanyName = @Original_CompanyName) AND (ContactName = @Original_ContactName OR @Original_ContactName IS NULL AND ContactName IS NULL) AND (ContactTitle = @Original_ContactTitle OR @Original_ContactTitle IS NULL AND ContactTitle IS NULL) AND (Country = @Original_Country OR @Original_Country IS NULL AND Country IS NULL) AND (Fax = @Original_Fax OR @Original_Fax IS NULL AND Fax IS NULL) AND (Phone = @Original_Phone OR @Original_Phone IS NULL AND Phone IS NULL) AND (PostalCode = @Original_PostalCode OR @Original_PostalCode IS NULL AND PostalCode IS NULL) AND (Region = @Original_Region OR @Original_Region IS NULL AND Region IS NULL)";
			this.sqlDeleteCommand3.Connection = this.sqlConnection1;
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_SupplierID", System.Data.SqlDbType.Int, 4, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "SupplierID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Address", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "City", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CompanyName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactTitle", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Country", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Fax", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Phone", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "PostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand3.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Region", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDataAdapter3
			// 
			this.sqlDataAdapter3.DeleteCommand = this.sqlDeleteCommand3;
			this.sqlDataAdapter3.InsertCommand = this.sqlInsertCommand3;
			this.sqlDataAdapter3.SelectCommand = this.sqlSelectCommand3;
			this.sqlDataAdapter3.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "Suppliers", new System.Data.Common.DataColumnMapping[] {
																																																				   new System.Data.Common.DataColumnMapping("SupplierID", "SupplierID"),
																																																				   new System.Data.Common.DataColumnMapping("CompanyName", "CompanyName"),
																																																				   new System.Data.Common.DataColumnMapping("ContactName", "ContactName"),
																																																				   new System.Data.Common.DataColumnMapping("ContactTitle", "ContactTitle"),
																																																				   new System.Data.Common.DataColumnMapping("Address", "Address"),
																																																				   new System.Data.Common.DataColumnMapping("City", "City"),
																																																				   new System.Data.Common.DataColumnMapping("Region", "Region"),
																																																				   new System.Data.Common.DataColumnMapping("PostalCode", "PostalCode"),
																																																				   new System.Data.Common.DataColumnMapping("Country", "Country"),
																																																				   new System.Data.Common.DataColumnMapping("Phone", "Phone"),
																																																				   new System.Data.Common.DataColumnMapping("Fax", "Fax"),
																																																				   new System.Data.Common.DataColumnMapping("HomePage", "HomePage")})});
			this.sqlDataAdapter3.UpdateCommand = this.sqlUpdateCommand3;
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemExpandAll,
																					  this.menuItemCollapseAll,
																					  this.menuItem7,
																					  this.menuItemPrint,
																					  this.menuItemPrintPreview,
																					  this.menuItem8,
																					  this.menuItemExit});
			this.menuItem1.Text = "&File";
			// 
			// menuItemExpandAll
			// 
			this.menuItemExpandAll.Index = 0;
			this.menuItemExpandAll.Text = "&Expand All";
			this.menuItemExpandAll.Click += new System.EventHandler(this.menuItemExpandAll_Click);
			// 
			// menuItemCollapseAll
			// 
			this.menuItemCollapseAll.Index = 1;
			this.menuItemCollapseAll.Text = "&Collapse All";
			this.menuItemCollapseAll.Click += new System.EventHandler(this.menuItemCollapseAll_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 2;
			this.menuItem7.Text = "-";
			// 
			// menuItemPrint
			// 
			this.menuItemPrint.Index = 3;
			this.menuItemPrint.Text = "&Print";
			this.menuItemPrint.Click += new System.EventHandler(this.menuItemPrint_Click);
			// 
			// menuItemPrintPreview
			// 
			this.menuItemPrintPreview.Index = 4;
			this.menuItemPrintPreview.Text = "Print Previe&w";
			this.menuItemPrintPreview.Click += new System.EventHandler(this.menuItemPrintPreview_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 5;
			this.menuItem8.Text = "-";
			// 
			// menuItemExit
			// 
			this.menuItemExit.Index = 6;
			this.menuItemExit.Text = "&Exit";
			this.menuItemExit.Click += new System.EventHandler(this.menuItemExit_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(720, 430);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridGroupingControl1});
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Syncfusion Essential Grid - PrintGroupingGrid";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

	}

	public class GridPrintToFitDocument : GridPrintDocument
	{
		private GridTableControl _grid;

		public GridPrintToFitDocument(GridTableControl grid, bool printPreview)
			: base(grid, printPreview)
		{
			_grid = grid;
		}

		protected override void OnPrintPage(System.Drawing.Printing.PrintPageEventArgs ev)
		{
			_grid.Model.Properties.PrintFrame = false;

			ev.HasMorePages = false;

			//draw a fullsize bitmap of the grid...
			int gridHeight = _grid.Model.RowHeights.GetTotal(0, _grid.Model.RowCount);
			int gridWidth = _grid.Model.ColWidths.GetTotal(0, _grid.Model.ColCount);

			Bitmap gridBM = new Bitmap(gridWidth, gridHeight);

			Graphics g = Graphics.FromImage(gridBM);

			Rectangle saveGridRect = this._grid.GridBounds;

			//GridBorderStyle savedBorderStyle = _grid.Model.Options.DefaultGridBorderStyle;

			GridGroupingControl groupingControl = _grid.GroupingControl;

			// Hook up GroupingControl_QueryCellStyleInfo while printing page
			groupingControl.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(GroupingControl_QueryCellStyleInfo);
			WireQueryColWidth(groupingControl.Table);
			
            Print(g, new Rectangle(Point.Empty, gridBM.Size), ev);

			// Unwire event.
			UnwireQueryColWidth(groupingControl.Table);
			groupingControl.QueryCellStyleInfo -= new GridTableCellStyleInfoEventHandler(GroupingControl_QueryCellStyleInfo);;

			g.Dispose();

			Rectangle destRect = ev.MarginBounds;
			

			//use the printer graphics
			g = ev.Graphics;

			//draw grid bitmap into the rect on the print page
			System.Drawing.GraphicsUnit gu = System.Drawing.GraphicsUnit.Point;
			RectangleF srcRect = gridBM.GetBounds(ref gu);


			//adjust destRect to make sizing proportional
			// you can comment this out this block if you don't want proportional fit
			float srcRatio =  srcRect.Width / srcRect.Height;
			float tarRatio = (float) destRect.Width / destRect.Height;
			if( tarRatio < srcRatio )
			{
				destRect.Height = (int) (destRect.Width / srcRatio);	
			}
			else
			{
				destRect.Width = (int) (destRect.Height * srcRatio);
			}
			//////////////endof proportional fit//////////////////////////

			g.DrawImage(gridBM,  destRect, srcRect, gu);
		}

		private void GroupingControl_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			
			// modify the appearance of cells while printing.
			GridGroupingControl gridGroupingControl = (GridGroupingControl) sender;
			if (!gridGroupingControl.TableControl.PrintingMode)
				return;
		
			GridTableCellStyleInfo style = (GridTableCellStyleInfo) e.Style;
			style.BackColor = Color.White;
			style.TextColor = Color.Black;
			style.Borders.All = GridBorder.Empty; //new GridBorder(GridBorderStyle.Solid, Color.Gray, GridBorderWeight.Medium);
			//style.Borders.Right = new GridBorder(GridBorderStyle.Solid, Color.Gray, GridBorderWeight.Medium);

				//style.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, Color.Gray, GridBorderWeight.Medium);

			switch (style.TableCellIdentity.TableCellType)
			{
				case GridTableCellType.GroupCaptionPlusMinusCell:
				case GridTableCellType.GroupCaptionCell:
					// Group caption cell.
					// PlusMinus cell in group caption.
					style.CellType = "Static";
					//style.Borders.Bottom = new GridBorder(GridBorderStyle.Solid, Color.Gray, GridBorderWeight.Medium);
					style.Borders.Top = new GridBorder(GridBorderStyle.Solid, Color.Gray, GridBorderWeight.Medium);
					style.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Horizontal, Color.Gray, Color.White);
					break;
		
		
				case GridTableCellType.None:
					// None.
					break;
		
				case GridTableCellType.EmptyCell:
					// Empty cells.
					break;
		
				case GridTableCellType.TopLeftHeaderCell:
				case GridTableCellType.RowHeaderCell:
				case GridTableCellType.ColumnHeaderCell:
				case GridTableCellType.ColumnHeaderWithFilterCell:
				case GridTableCellType.RecordRowHeaderCell:
					// The top-left header cell.
					// Any row header cell.
					// Column header cell.
					// Filter bar header cell.
					// Any header cell in a record row.
		
		
				case GridTableCellType.RecordPlusMinusCell:
					// PlusMinus cell in a record row.
					style.CellType = "Static";
					break;
		
				case GridTableCellType.AddNewRecordFieldCell:
				case GridTableCellType.AlternateRecordFieldCell:
				case GridTableCellType.RecordFieldCell:
					// Field cell in a non-alternate record row.
					// Field cell in an alternate record row.
					// Field cell in new record row.
					if (e.TableCellIdentity.Table.TableDescriptor.Name == "Products")
						style.BackColor = Color.Wheat;
					break;

				case GridTableCellType.RecordPreviewRowHeaderCell:
					// Any header cell in a record preview row.
		
				case GridTableCellType.GroupFooterRowHeaderCell:
					// Any header cell in a group footer.
		
				case GridTableCellType.GroupHeaderRowHeaderCell:
					// Any header cell in a group header.
		
				case GridTableCellType.GroupPreviewRowHeaderCell:
					// Any header cell in a group preview section.
		
				case GridTableCellType.AddNewRecordRowHeaderCell:
					// Any header cell in a new record row.
		
				case GridTableCellType.AlternateRecordRowHeaderCell:
					// Any header cell in an alternate record row.
		
				case GridTableCellType.GroupCaptionRowHeaderCell:
					// Any cell in a group caption.
		
				case GridTableCellType.FilterBarRowHeaderCell:
					// Any filter bar row header cell.
		
				case GridTableCellType.EmptySectionRowHeaderCell:
					// Any row header cell in an empty section.
		
				case GridTableCellType.NestedTableRowHeaderCell:
					// Row header cell in parent table for rows with indented nested table.
		
					style.CellType = "Static";
					break;
		
				case GridTableCellType.RecordPreviewCell:
					// Cell in record preview row.
					break;
		
				case GridTableCellType.GroupPreviewCell:
					// Cell in group preview section.
					break;
		
				case GridTableCellType.NestedTableIndentCell:
					// Indent cell in parent table for rows with indented nested table.
					break;
		
				case GridTableCellType.NestedTableIndentTCell:
					// Indent cell with T-line in parent table for rows with indented nested table.
					break;
		
				case GridTableCellType.NestedTableIndentLCell:
					// Indent cell with closing L-line in parent table for rows with indented nested table.
					break;
		
				case GridTableCellType.NestedTableIndentICell:
					// Indent cell with continuous I-line in parent table for rows with indented nested table.
					break;
		
				case GridTableCellType.NestedTableCell:
					// The nested table cell in which the nested table is drawn.
					break;
		
				case GridTableCellType.GroupIndentCell:
					// Indent cell in group.
					break;
		
				case GridTableCellType.GroupIndentICell:
					// Indent cell with continuous I-line in group.
					break;
		
				case GridTableCellType.GroupIndentTCell:
					// Indent cell with T-line in group.
					break;
		
				case GridTableCellType.GroupIndentLCell:
					// Indent cell with closing L-line in group.
					break;
		
				case GridTableCellType.GroupHeaderSectionCell:
					// Any cell in group header section.
					break;
		
				case GridTableCellType.GroupFooterSectionCell:
					// Any cell in group footer section.
					break;
		
				case GridTableCellType.GroupHeaderIndentCell:
					// Indent cell in group header section.
					break;
		
				case GridTableCellType.GroupFooterIndentCell:
					// Indent cell in group footer section.
					break;
		
				case GridTableCellType.FilterBarCell:
					// Field cell in filter bar.
					break;
		
				case GridTableCellType.SummaryFieldCell:
					// Field cell in summary row.
					break;
		
				case GridTableCellType.SummaryFillRowCell:
					// Field cell in summary row with GridSummaryStyle.FillRow.
					break;
		
				case GridTableCellType.SummaryTitleCell:
					// Title cell in summary row.
					break;
		
				case GridTableCellType.SummaryRowHeaderCell:
					// Row header cell in summary row.
					break;
		
				case GridTableCellType.SummaryEmptyCell:
					// Empty cell in summary row.
					break;
		
				case GridTableCellType.GroupCaptionSummaryCell:
					// Summary cell in caption bar.
					break;
			}

		}

		void WireQueryColWidth(GridTable table)
		{
			if (table.TableModel == null)
				return; 
			table.TableModel.QueryColWidth += new GridRowColSizeEventHandler(Model_QueryColWidth);
			foreach (GridTable t in table.RelatedTables)
				WireQueryColWidth(t);
		}

		void UnwireQueryColWidth(GridTable table)
		{
			if (table.TableModel == null)
				return; 
			table.TableModel.QueryColWidth -= new GridRowColSizeEventHandler(Model_QueryColWidth);
			foreach (GridTable t in table.RelatedTables)
				UnwireQueryColWidth(t);
		}

		private void Model_QueryColWidth(object sender, GridRowColSizeEventArgs e)
		{
			// modify the appearance of cells while printing.
			GridTableModel tableModel = (GridTableModel) sender;
			GridTableDescriptor td = tableModel.Table.TableDescriptor;
			GridGroupingControl gridGroupingControl = tableModel.Table.Engine.GroupingControl;
			if (!gridGroupingControl.TableControl.PrintingMode)
				return;
		
			if (e.Index < td.GetColumnIndentCount())
			{
				e.Size = 0;
				e.Handled = true;
			}

		}
	}


	[ToolboxItem(false)]
	public class GridPrintDocument: PrintDocument
	{
		GridControlBase m_grid;
		int m_nCurPage = 0;
		internal bool m_printPreview = false;
		int fromPage = 0;
		int toPage = int.MaxValue;


		/// <summary>
		/// Initializes a new <see cref="GridPrintDocument"/> for a grid.
		/// </summary>
		/// <param name="grid">The parent grid for this object.</param>
		public GridPrintDocument(GridControlBase grid)
		{
			m_grid = grid;
		}

		/// <summary>
		/// Initializes a new <see cref="GridPrintDocument"/> for a grid.
		/// </summary>
		/// <param name="grid">The parent grid for this object.</param>
		/// <param name="printPreview">True if print preview; False if printing.</param>
		public GridPrintDocument(GridControlBase grid, bool printPreview)
		{
			m_grid = grid;
			// m_printPreview is meant for future use - right now this is not
			// working and will only break printing code. (only one page will be printed then ...)
			//m_printPreview = printPreview;
		}

		/// <summary>
		/// Returns whether this object is in print preview mode or if it is output to a printer.
		/// </summary>
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public bool IsPrintPreview
		{
			get
			{
				return m_printPreview;
			}
		}

		/// <override/>
		protected override void OnBeginPrint(PrintEventArgs ev) 
		{
			TraceUtil.TraceCurrentMethodInfoIf(true, "BEGIN");
			base.OnBeginPrint(ev) ;
			m_nCurPage = 0;

			GridProperties pProp = m_grid.Model.Properties;

			m_grid.Model.PushPrintFloatingCells();
			m_grid.PrintInfo.m_awPageFirstRow = new ArrayList();
			m_grid.PrintInfo.m_awPageFirstCol = new ArrayList();

			int      nCurRow = m_grid.TopRowIndex,
				nCurCol = m_grid.LeftColIndex;

			int nTopRow = m_grid.TopRowIndex;
			int nLeftCol = m_grid.LeftColIndex;

			m_grid.PrintInfo.m_bPrintPaintMsg = false;

			m_grid.PrintingMode = true;

			try
			{
				// PrintBounds gets returned by GridBounds while in PrintingMode.
				Rectangle bounds = this.DefaultPageSettings.Bounds;
				bounds.Width -= this.DefaultPageSettings.Margins.Left + this.DefaultPageSettings.Margins.Right;
				bounds.Height -= this.DefaultPageSettings.Margins.Top + this.DefaultPageSettings.Margins.Bottom;
				m_grid.PrintBounds = bounds;
				Rectangle rectGrid = m_grid.GridBounds;

				// Compute page breaks.

				GridRangeInfoList pSelList = m_grid.Model.SelectedRanges;
				GridRangeInfo selRange = pSelList.ActiveRange;
				bool isSel = (selRange.Width > 1 || selRange.Height > 1);

				bool printSel = this.PrinterSettings.PrintRange == PrintRange.Selection;//  || this.m_printPreview;
				//|| this.PrintController is PreviewPrintController;

				bool printPages = this.PrinterSettings.PrintRange == PrintRange.SomePages;
				fromPage = printPages ? this.PrinterSettings.FromPage : 1;
				toPage = printPages ? this.PrinterSettings.ToPage : int.MaxValue;
				
				bool bCurPageOnly = printSel && !isSel;
				bool bCurSelOnly = printSel && isSel;

				if (bCurPageOnly)
				{
					int      bottomRow,
						rightCol;

					// Just use top left cell.
					m_grid.PrintInfo.m_nPrintTopRow = nTopRow;
					m_grid.PrintInfo.m_nPrintLeftCol = nLeftCol;
					m_grid.PrintInfo.m_awPageFirstCol.Add(m_grid.PrintInfo.m_nPrintLeftCol);
					m_grid.PrintInfo.m_awPageFirstRow.Add(m_grid.PrintInfo.m_nPrintTopRow);
					m_grid.ViewLayout.Reset();

					// ... and calculate boottom right cell.
					rightCol = m_grid.ViewLayout.LastVisibleCol;
					bottomRow = m_grid.ViewLayout.LastVisibleRow;

					if (!m_grid.ViewLayout.HasPartialVisibleCols)
						rightCol++;
					if (!m_grid.ViewLayout.HasPartialVisibleRows)
						bottomRow++;
					m_grid.PrintInfo.m_awPageFirstCol.Add(rightCol);
					m_grid.PrintInfo.m_awPageFirstRow.Add(bottomRow);
					this.PrinterSettings.ToPage = 1;
					this.PrinterSettings.MaximumPage = 1;
				}
				else
				{

					GridRangeInfo rangePrint;

					// ExpandRange is necessary if user wants to
					// print selected rows or columns.
					if (bCurSelOnly)
						rangePrint = pSelList.ActiveRange;
					else
						rangePrint = GridRangeInfo.Table();

					rangePrint = rangePrint.ExpandRange(
						m_grid.InternalGetFrozenRows()+1,
						m_grid.InternalGetFrozenCols()+1,
						m_grid.Model.RowCount,
						m_grid.Model.ColCount);

					int      bottomRow,
						rightCol;

					// I must take care of frozen rows and columns
					m_grid.PrintInfo.m_nPrintTopRow = Math.Max(m_grid.InternalGetFrozenRows()+1, rangePrint.Top);
					m_grid.PrintInfo.m_nPrintLeftCol = Math.Max(m_grid.InternalGetFrozenCols()+1, rangePrint.Left);
					
					//commented out to handle Issue#356
					//m_grid.PrintInfo.m_bPrintCurSelOnly = bCurSelOnly;
 
					m_grid.PrintInfo.m_awPageFirstCol.Add(m_grid.PrintInfo.m_nPrintLeftCol);
					m_grid.PrintInfo.m_nCurrentPageColIndex = 0;
					m_grid.PrintInfo.m_nCurrentPageRowIndex = 0;
					m_grid.ViewLayout.Reset();



					// Compute left column for each page.
					int nPage = 0;
					bool bEOF = false;
					while (!bEOF)
					{
						bool isLargeColumn = false;
						rightCol = m_grid.ViewLayout.LastVisibleCol;

						if (rightCol <= m_grid.PrintInfo.m_nPrintLeftCol)
						{
							isLargeColumn = true;
						}

						bEOF = !m_grid.ViewLayout.HasPartialVisibleCols;
						if (bEOF || rightCol == m_grid.PrintInfo.m_nPrintLeftCol)
							rightCol++;

						if (rightCol > rangePrint.Right)
						{
							rightCol = rangePrint.Right+1;
							bEOF = true;
						}

						++nPage;
						if (nPage < m_grid.PrintInfo.m_awPageFirstCol.Count)
							m_grid.PrintInfo.m_awPageFirstCol[nPage] = rightCol;
						else
							m_grid.PrintInfo.m_awPageFirstCol.Add(rightCol);
						m_grid.PrintInfo.m_nPrintLeftCol = rightCol;
						if (isLargeColumn)
							m_grid.PrintInfo.m_nPrintLeftCol++;
						m_grid.ViewLayout.Reset();
					}

					m_grid.PrintInfo.m_nPrintTopRow = Math.Max(m_grid.InternalGetFrozenRows()+1, rangePrint.Top);
					m_grid.PrintInfo.m_nPrintLeftCol = Math.Max(m_grid.InternalGetFrozenCols()+1, rangePrint.Left);
					m_grid.PrintInfo.m_awPageFirstRow.Add(m_grid.PrintInfo.m_nPrintTopRow);
					m_grid.ViewLayout.Reset();

					// Compute top row for each page.
					nPage = 0;
					bEOF = false;
					while (!bEOF)
					{
						bool isLargeRow = false;
						bottomRow = m_grid.ViewLayout.LastVisibleRow;

						if (bottomRow <= m_grid.PrintInfo.m_nPrintTopRow)
						{
							isLargeRow = true;
						}

						bEOF = !m_grid.ViewLayout.HasPartialVisibleRows;
						if (bEOF || bottomRow == m_grid.PrintInfo.m_nPrintTopRow)
							bottomRow++;

						if (bottomRow > rangePrint.Bottom)
						{
							bottomRow = rangePrint.Bottom+1;
							bEOF = true;
						}
						else if (bottomRow == rangePrint.Bottom)
							bEOF = true;

						++nPage;
						if (nPage < m_grid.PrintInfo.m_awPageFirstRow.Count)
							m_grid.PrintInfo.m_awPageFirstRow[nPage] = bottomRow;
						else
							m_grid.PrintInfo.m_awPageFirstRow.Add(bottomRow);
						m_grid.PrintInfo.m_nPrintTopRow = bottomRow;
						if (isLargeRow)
							m_grid.PrintInfo.m_nPrintTopRow++;
						m_grid.ViewLayout.Reset();
					}

					// Set no of pages.
					this.PrinterSettings.ToPage = (m_grid.PrintInfo.m_awPageFirstRow.Count-1)*(m_grid.PrintInfo.m_awPageFirstCol.Count-1);
					this.PrinterSettings.MaximumPage = this.PrinterSettings.ToPage;

					if (m_printPreview || this.PrintController is PreviewPrintController)
					{
						if (pProp.PageOrder == 0)
							m_nCurPage = m_grid.PrintInfo.m_nCurrentPageRowIndex*(m_grid.PrintInfo.m_awPageFirstCol.Count-1)
								+m_grid.PrintInfo.m_nCurrentPageColIndex + 1;
						else
							m_nCurPage = m_grid.PrintInfo.m_nCurrentPageColIndex*(m_grid.PrintInfo.m_awPageFirstRow.Count-1)
								+m_grid.PrintInfo.m_nCurrentPageRowIndex + 1;
					}
					else
						m_nCurPage = fromPage-1;
				}

				// Reset printing mode.
				m_grid.PrintingMode = false;
			}
			finally
			{
				// Reset printing mode.
				m_grid.PrintingMode = false;
			}
			TraceUtil.TraceCurrentMethodInfoIf(true, "END");
		}

		//Override the OnPrintPage to provide the printing logic for the document.
		/// <override/>
		protected override void OnPrintPage(PrintPageEventArgs ev) 
		{
			Print(ev.Graphics, ev.MarginBounds, ev);
		}

		protected void Print(Graphics evGraphics, Rectangle evMarginBounds, PrintPageEventArgs ev) 
		{
			TraceUtil.TraceCurrentMethodInfoIf(true, "BEGIN");
			TraceUtil.TraceCurrentMethodInfoIf(true, ev.HasMorePages, ev.MarginBounds, ev.PageBounds, ev.PageSettings);
			base.OnPrintPage(ev) ;

			// TODO: how to access page numer of print controller?
			m_nCurPage++;
            
			GridProperties pProp = m_grid.Model.Properties;

			int      bottomRow,
				rightCol;

			m_grid.PrintInfo.m_bPrintPaintMsg = false;
			m_grid.PrintingMode  = true;

			try
			{
				// Check page break array.
				if (m_grid.PrintInfo.m_awPageFirstRow.Count == 0
					|| m_grid.PrintInfo.m_awPageFirstCol.Count == 0)
				{
					Trace.WriteLineIf(true, "Warning! You must call OnBeginPrinting and OnEndPrinting from your derived class!\n");
					Debug.Assert(false);
				}

				//m_grid.OnAdjustPrintRectangle(g, pInfo);
				//                Rectangle bounds = this.DefaultPageSettings.Bounds;
				//                bounds.Width -= this.DefaultPageSettings.Margins.Left + this.DefaultPageSettings.Margins.Right;
				//                bounds.Height -= this.DefaultPageSettings.Margins.Top + this.DefaultPageSettings.Margins.Bottom;
				//                m_grid.PrintBounds = bounds;
				m_grid.PrintBounds = evMarginBounds;

				// Page order.
				int nPageRowIndex = 0;
				int nPageColIndex = 0;

				// Page order.
				if (pProp.PageOrder == 0)
				{
					nPageRowIndex = (m_nCurPage-1)/(m_grid.PrintInfo.m_awPageFirstCol.Count-1);
					nPageColIndex = (m_nCurPage-1)%(m_grid.PrintInfo.m_awPageFirstCol.Count-1);
				}
				else
				{
					nPageRowIndex = (m_nCurPage-1)%(m_grid.PrintInfo.m_awPageFirstRow.Count-1);
					nPageColIndex = (m_nCurPage-1)/(m_grid.PrintInfo.m_awPageFirstRow.Count-1);
				}

				m_grid.PrintInfo.m_nCurrentPageColIndex = nPageColIndex;
				m_grid.PrintInfo.m_nCurrentPageRowIndex = nPageRowIndex;
				
				// top left cell
				m_grid.PrintInfo.m_nPrintTopRow = (int) m_grid.PrintInfo.m_awPageFirstRow[nPageRowIndex];
				m_grid.PrintInfo.m_nPrintLeftCol = (int) m_grid.PrintInfo.m_awPageFirstCol[nPageColIndex];
				m_grid.ViewLayout.Reset();


				Rectangle rectGrid = m_grid.GridBounds;

				GridRangeInfoList pSelList = m_grid.Model.SelectedRanges;
				GridRangeInfo selRange = pSelList.ActiveRange;
				bool isSel = (selRange.Width > 1 || selRange.Height > 1);

				bool printSel = this.PrinterSettings.PrintRange == PrintRange.Selection 
					|| this.PrintController is PreviewPrintController || this.m_printPreview;

				bool bCurPageOnly = printSel && !isSel;
				bool bCurSelOnly = printSel && isSel;

				// ... and bottom right cell.
				if (nPageRowIndex+1 < m_grid.PrintInfo.m_awPageFirstRow.Count)
					bottomRow = m_grid.GetClientRow(Math.Min(m_grid.Model.RowCount+1, (int) m_grid.PrintInfo.m_awPageFirstRow[nPageRowIndex+1]))-1;
				else
					bottomRow = m_grid.GetClientRow(m_grid.Model.RowCount);

				if (nPageColIndex+1 < m_grid.PrintInfo.m_awPageFirstCol.Count)
					rightCol = m_grid.GetClientCol(Math.Min(m_grid.Model.ColCount+1, (int) m_grid.PrintInfo.m_awPageFirstCol[nPageColIndex+1]))-1;
				else
					rightCol = m_grid.GetClientCol(m_grid.Model.ColCount);

				// Compute drawing rectangle.
				int x, y;
				Rectangle rectPrint = m_grid.PrintBounds;

				Point corner = m_grid.ViewLayout.ClientRowColToPoint(bottomRow+1, rightCol+1, GridCellSizeKind.ActualSize);

				if (m_grid.IsRightToLeft())
				{
					x = Math.Min(rectPrint.Width, rectPrint.Right-corner.X);
					y = Math.Min(rectPrint.Height, corner.Y-rectPrint.Top);
				}
				else
				{
					x = Math.Min(rectPrint.Width, corner.X-rectPrint.Left);
					y = Math.Min(rectPrint.Height, corner.Y-rectPrint.Top);
				}

				int rl, rt;
				// ... and center it.
				if (pProp.CenterHorizontal)
					rl = rectPrint.Left + (rectPrint.Width-x)/2;
				else
					rl = rectPrint.Left;

				if (pProp.CenterVertical)
					rt = rectPrint.Top + (rectPrint.Height-y)/2;
				else
					rt = rectPrint.Top;
        
				m_grid.PrintBounds = new Rectangle(rl, rt, x+1, y+1);
				m_grid.ViewLayout.Reset();

				rectPrint = new Rectangle(rl-1, rt-1, x+1, y+1);

				TraceUtil.TraceCurrentMethodInfoIf(true, "Clip", rectPrint);
				Region clip = evGraphics.Clip;
				evGraphics.IntersectClip(rectPrint);

				m_grid.Model.FloatingCells.EvaluateFloatingCells(
					GridRangeInfo.Cells(
					m_grid.GetRow(1), m_grid.GetCol(1),
					m_grid.GetRow(bottomRow), m_grid.GetCol(rightCol)));

				m_grid.Model.MergeCells.EvaluateMergeCells(
					GridRangeInfo.Cells(
					m_grid.GetRow(1), m_grid.GetCol(1),
					m_grid.GetRow(bottomRow), m_grid.GetCol(rightCol)));

				// Draw page.
				m_grid.OnDrawClientRowCol(0, 0, bottomRow, rightCol, evGraphics, rectPrint);

				// Check if there are pages to go.
				ev.HasMorePages = !bCurPageOnly && 
					(nPageRowIndex+2 < m_grid.PrintInfo.m_awPageFirstRow.Count || 
					nPageColIndex+2 < m_grid.PrintInfo.m_awPageFirstCol.Count) &&
					this.m_nCurPage < this.toPage;

				evGraphics.Clip = clip;

				// Draw border around grid.
				if (pProp.PrintFrame)
				{
					Rectangle rectFrame = new Rectangle(rl-1, rt-1, x+1, y+1);
					int penWidth  = 2;
					rectFrame.Inflate(penWidth-3, penWidth-3);
					Pen pen = new Pen(Color.Black, penWidth);
					evGraphics.DrawRectangle(pen, rectFrame);
					pen.Dispose();
					//					Brush br = new SolidBrush(Color.Black);
					//					ev.Graphics.FillRectangle(br, rl-2, rt-2, x+3, 1);
					//					ev.Graphics.FillRectangle(br, rl-2, rt+y, x+3, 1);
					//					ev.Graphics.FillRectangle(br, rl-2, rt-2, 1, y+3);
					//					ev.Graphics.FillRectangle(br, rl+x, rt-2, 1, y+3);
				}

				// Reset printing mode.
				m_grid.PrintingMode = false;
			}
			finally
			{
				// Reset printing mode.
				m_grid.PrintingMode = false;
			}

			TraceUtil.TraceCurrentMethodInfoIf(true, "END");
		}

		/// <override/>
		protected override void OnEndPrint(PrintEventArgs e)  
		{
			TraceUtil.TraceCurrentMethodInfoIf(true, "BEGIN");
			m_grid.Model.ResetPrintFloatingCells();
			m_grid.PrintInfo.m_awPageFirstRow = null;
			m_grid.PrintInfo.m_awPageFirstCol = null;
			TraceUtil.TraceCurrentMethodInfoIf(true, "END");
		}

	}

}